#include <bits/stdc++.h>
using namespace std;
int n, mat[10005][10005];
int o,a,b,ab,resenje;
struct slog{
    string grupa;
    int koliko;
};
slog pacijenti[10005];
int main (){
    cin>>n;
    cin>>o>>a>>b>>ab;
    for(int i=1; i<=n; i++){
        cin>>pacijenti[i].grupa>>pacijenti[i].koliko;
    }
    for(int i=1; i<=n; i++){
        if(pacijenti[i].grupa=="O" and o>=pacijenti[i].koliko){
            mat[i][1]+=pacijenti[i].koliko;
            o-=pacijenti[i].koliko;
            pacijenti[i].koliko=0;
        }
    }
    for(int i=1; i<=n; i++){
        if(pacijenti[i].grupa=="A"){
                if(a>0){
          if(a>=pacijenti[i].koliko){
                mat[i][2]+=pacijenti[i].koliko;
                a-=pacijenti[i].koliko;
                pacijenti[i].koliko=0;
          }
          else{
            mat[i][2]+=a;
            pacijenti[i].koliko-=a;
            a=0;
           }
                }
                if(o>0){
            if(o>=pacijenti[i].koliko){
                mat[i][1]+=pacijenti[i].koliko;
                o-=pacijenti[i].koliko;
                pacijenti[i].koliko=0;
            }
          else{
            mat[i][1]+=o;
            pacijenti[i].koliko-=o;
            o=0;
          }
        }
        }
    }
         for(int i=1; i<=n; i++){
        if(pacijenti[i].grupa=="B"){
                if(b>0){
            if(b>=pacijenti[i].koliko){
                mat[i][3]+=pacijenti[i].koliko;
                b-=pacijenti[i].koliko;
                pacijenti[i].koliko=0;
            }
          else{
            mat[i][3]+=b;
            pacijenti[i].koliko-=b;
            b=0;
          }
        }
        if(o>0){
           if(o>=pacijenti[i].koliko){
                mat[i][1]+=pacijenti[i].koliko;
                o-=pacijenti[i].koliko;
                pacijenti[i].koliko=0;
          }
          else{
            mat[i][1]+=o;
            pacijenti[i].koliko-=o;
            o=0;
          }
        }
        }
         }
         for(int i=1; i<=n; i++){
        if(pacijenti[i].grupa=="AB"){
            if(ab>0){
             if(ab>=pacijenti[i].koliko){
                mat[i][4]+=pacijenti[i].koliko;
                ab-=pacijenti[i].koliko;
                pacijenti[i].koliko=0;
             }
             else{
                mat[i][4]+=ab;
                pacijenti[i].koliko-=ab;
                ab=0;
             }
            }
             if(a>0){
               if(a>=pacijenti[i].koliko){
                 mat[i][2]+=pacijenti[i].koliko;
                 a-=pacijenti[i].koliko;
                 pacijenti[i].koliko=0;
               }
               else{
                mat[i][2]+=a;
                pacijenti[i].koliko-=a;
                a=0;
               }
            }
            if(b>0){
              if(b>=pacijenti[i].koliko){
                 mat[i][3]+=pacijenti[i].koliko;
                 b-=pacijenti[i].koliko;
                 pacijenti[i].koliko=0;
               }
              else{
                mat[i][3]+=b;
                pacijenti[i].koliko-=b;
                b=0;
              }
            }
            if(o>0){
              if(o>=pacijenti[i].koliko){
                 mat[i][1]+=pacijenti[i].koliko;
                 o-=pacijenti[i].koliko;
                 pacijenti[i].koliko=0;
              }
              else{
                mat[i][1]+=o;
                pacijenti[i].koliko-=o;
                o=0;
              }
            }
        }
    }
    for(int i=1; i<=n; i++){
        if(pacijenti[i].koliko>0)
          resenje++;
     }
     if(resenje>0){
        cout<<"nemoguce"<<endl;
     }
     else{
        cout<<"moguce"<<endl;
        for(int i=1; i<=n; i++){
        for(int j=1; j<=4; j++){
            cout<<mat[i][j]<<" ";
        }
        cout<<endl;
        }
     }
return 0;
}